// Copyright (c) 2024-2026 Celestino Amoroso (celestino.amoroso@gmail.com).
// All rights reserved.

// operator-in.go
package expr

import (
	"git.portale-stac.it/go-pkg/expr/kern"
	"git.portale-stac.it/go-pkg/expr/scan"
	"git.portale-stac.it/go-pkg/expr/sym"
	"git.portale-stac.it/go-pkg/expr/types/array"
	"git.portale-stac.it/go-pkg/expr/types/dict"
	"git.portale-stac.it/go-pkg/expr/types/interval"
	"git.portale-stac.it/go-pkg/expr/types/list"
)

//-------- in term

func newInTerm(tk *scan.Token) (inst *scan.Term) {
	return &scan.Term{
		Tk:       *tk,
		Children: make([]*scan.Term, 0, 2),
		Position: scan.PosInfix,
		Priority: scan.PriRelational,
		EvalFunc: evalIn,
	}
}

// func hasKey(d map[any]any, target any) (ok bool) {
// 	_, ok = d[target]
// 	return
// }

func evalIn(ctx kern.ExprContext, opTerm *scan.Term) (v any, err error) {
	var leftValue, rightValue any

	if leftValue, rightValue, err = opTerm.EvalInfix(ctx); err != nil {
		return
	}

	if array.IsArray(rightValue) {
		a, _ := rightValue.(*array.ArrayType)
		v = a.IndexDeepSameCmp(leftValue) >= 0
	} else if dict.IsDict(rightValue) {
		dict, _ := rightValue.(*dict.DictType)
		v = dict.HasKey(leftValue)
	} else if list.IsLinkedList(rightValue) {
		ls, _ := rightValue.(*list.LinkedList)
		v = ls.HasValue(leftValue)
	} else if interval.IsInterval(rightValue) {
		r, _ := rightValue.(*interval.IntervalType)
		v = r.Contains(leftValue)
	} else {
		err = opTerm.ErrIncompatibleTypes(leftValue, rightValue)
	}
	return
}

// init
func init() {
	scan.RegisterTermConstructor(sym.SymKwIn, newInTerm)
}
